;JAM's 100 Extra Events Modified
;Disassembled and modified by OmegaDragnet9

;Version 2.3

;Made to work in SMART
;Had to completely overhaul this to work in the editor.
;Copies a lot of vanilla routines.

;To use in SMART, make sure this is in your project XML file:
    ; <StateCondition TestCodeAddress="E61E">
      ; <Arguments>
        ; <ArgType Name="Extra Events" Type="Byte" Action="Events" />
      ; </Arguments>
      ; <Name>Extra event bit is set 0100</Name>
    ; </StateCondition>
    ; <StateCondition TestCodeAddress="E621">
      ; <Arguments>
        ; <ArgType Name="Extra Extra Events" Type="Byte" Action="Events" />
      ; </Arguments>
      ; <Name>Extra event bit is set 0200</Name>
    ; </StateCondition>

;This is for the Items Collected and Doors Opened roomstates 

    ; <StateCondition TestCodeAddress="E625">
      ; <Arguments>
        ; <ArgType Name="Item State" Type="Byte" Action="Events" />
      ; </Arguments>
      ; <Name>Item is collected</Name>
    ; </StateCondition>
    ; <StateCondition TestCodeAddress="E67B">
      ; <Arguments>
        ; <ArgType Name="Item State 0100" Type="Byte" Action="Events" />
      ; </Arguments>
      ; <Name>Item is collected 0100</Name>
    ; </StateCondition>
    ; <StateCondition TestCodeAddress="E67E">
      ; <Arguments>
        ; <ArgType Name="Door State" Type="Byte" Action="Events" />
      ; </Arguments>
      ; <Name>Door is opened</Name>
    ; </StateCondition>
    ; <StateCondition TestCodeAddress="E681">
      ; <Arguments>
        ; <ArgType Name="Door State 0100" Type="Byte" Action="Events" />
      ; </Arguments>
      ; <Name>Door is opened</Name>
    ; </StateCondition>

lorom

;What's happening leading up to it:

; org $8FE612

; LDA $0000,x
; AND #$00FF
; JSL $808233

org $8FE61C

;;;;Bytes from the patch:
;;;;DB $80,$15

; Vanilla 
; BCC $07 [$E625]

; JAM
BRA $15 ;[$E633]

;org $8FE633

;BCC $07
;LDA $0001,x
;TAX
;JMP $E5E6
;INX
;INX
;INX
;RTS

;This move takes advantage of the fact that the rest of this code can go to the second half of $E629's code.
;This makes space for what JAM is going to alter at $8FE61E

;However, I really had to deviate from JAM's code from this point on, and it really ends up being slightly tweaked Vanilla code.

;STATES
org $8FE61E
JMP EXTENDED_EVENT ;$E1E0

org $8FE621
JMP EXTENDED_EVENT2

org $8FE625
JMP ITEM_EVENT1

;This section completely repoints the Speedbooster is Collected State, but still respects its location because SMART will not let it be replaced.

org $8FE678
JMP SPEEDBOOSTER

org $8FE67B
JMP ITEM_EVENT2

org $8FE67E
JMP DOOR_EVENT1

org $8FE681
JMP DOOR_EVENT2

org $8FE1E0
;Handles JAM's Extended Events
;Covers events $100-$1FF
EXTENDED_EVENT:
LDA $0000,x 
AND #$00FF             
JSL EVENTCHECK1 ;} If event [[X]] is marked:
BCC END1    
JMP STATEPOINTER

STATEPOINTER:
LDA $0001,x 
TAX                    ;} X = [[X] + 1]
JMP $E5E6              ; Go to use state pointer [X]

END1:
INX                    
INX                    
INX                    
RTS

;Handles the $80 bytes beyond what JAM provided. Any further than Event $27F and you start deleting items. 
;Covers events $200-$27F
EXTENDED_EVENT2:
LDA $0000,x 
AND #$00FF             
JSL EVENTCHECK2  ;} If event [[X]] is marked:
BCC END1 
JMP STATEPOINTER

;Handles $00-$FF Items. Makes Items collected into a Roomstate.
ITEM_EVENT1:
LDA $0000,x 
AND #$00FF             
JSL EVENTCHECK3  ;} If event [[X]] is marked:
BCC END1 
JMP STATEPOINTER

;Handles $100-$1FF Items. Makes Items collected into a Roomstate.
ITEM_EVENT2:
LDA $0000,x 
AND #$00FF             
JSL EVENTCHECK4  ;} If event [[X]] is marked:
BCC END1 
JMP STATEPOINTER

;Handles Door $00-$FF. Makes doors opened trigger a Roomstate.
DOOR_EVENT1:
LDA $0000,x 
AND #$00FF             
JSL EVENTCHECK5  ;} If event [[X]] is marked:
BCC END1 
JMP STATEPOINTER

;Handles Door $100-$1FF. Makes doors opened trigger a Roomstate.
DOOR_EVENT2:
LDA $0000,x 
AND #$00FF             
JSL EVENTCHECK6  ;} If event [[X]] is marked:
BCC END1 
JMP STATEPOINTER

SPEEDBOOSTER:
;Moved here because SMART would not let it be replaced.
;;; $E678: Unused. Room state check: speed booster ;;;
{
LDA $09A4  
AND #$2000             ;} If speed booster collected:
BEQ $07        
LDA $0000,x            ;\
TAX                    ;} X = [[X]]
JMP $E5E6    

INX                    ;\
INX                    ;} X += 2
RTS

;-------------------------------------------------------

;The New "Event" checks.
;A lot of PHY and PHP opcodes left in because they were in Vanilla, but they're commented out because I think it's really just PHX that was necessary.
org $80F400

;Events $100-$1FF
EVENTCHECK1:

PHX
; PHY
; PHP
REP #$30
JSL $80818E 
LDA $7ED840,x 	;
AND $05E7  
BNE END3 
; PLP
; PLY
PLX
CLC
RTL

END3:
;PLP
;PLY
PLX
SEC
RTL

;Events $200-$27F
EVENTCHECK2:

PHX
; PHY
; PHP
REP #$30
JSL $80818E  
LDA $7ED860,x  
AND $05E7   
BNE END3  
; PLP
; PLY
PLX
CLC
RTL

;Item Array 1, Items $00-$FF
EVENTCHECK3:

PHX
; PHY
; PHP
REP #$30
JSL $80818E  
LDA $7ED870,x  
AND $05E7   
BNE END3  
; PLP
; PLY
PLX
CLC
RTL

;Item Array 2, Items $100-$1FF
EVENTCHECK4:

PHX
; PHY
; PHP
REP #$30
JSL $80818E  
LDA $7ED890,x  
AND $05E7   
BNE END3  
; PLP
; PLY
PLX
CLC
RTL

;Door Array 1, Doors $00-$FF
EVENTCHECK5:

PHX
; PHY
; PHP
REP #$30
JSL $80818E  
LDA $7ED8B0,x  
AND $05E7   
BNE END3  
; PLP
; PLY
PLX
CLC
RTL

;Door Array 2, Doors $100-$1FF
EVENTCHECK6:

PHX
; PHY
; PHP
REP #$30
JSL $80818E  
LDA $7ED8D0,x  
AND $05E7   
BNE END3  
; PLP
; PLY
PLX
CLC
RTL
